from pymongo.errors import PyMongoError

from efs.server.exceptions import InvalidUserError
from efs.server.exceptions import InvalidGroupError

class StructService(object):

	def __init__(self, mongo_client):
		self.mongo_client = mongo_client
		try:
			self.struct_db = mongo_client.struct
			self.user_struct = self.struct_db.user_struct
			self.group_struct = self.struct_db.group_struct
		except:
			raise PyMongoError

	def get_user_struct(self, user):
		struct_record = self.user_struct.find({"user":user})
		if struct_record.count() == 1:
			return struct_record[0]["struct"]
		else:
			raise InvalidUserError

	def update_user_struct(self, user, struct):
		struct_record = self.user_struct.find({"user":user})
		if struct_record.count() == 1:
			self.user_struct.update({"user":user}, {"$set": {"struct": struct}})
		else:
			self.user_struct.insert({"user": user, "struct": struct})

	def get_group_struct(self, group):
		struct_record = self.group_struct.find({"group":group})
		if struct_record.count() == 1:
			return struct_record[0]["struct"]
		else:
			raise InvalidGroupError

	def update_group_struct(self, group, struct):
		struct_record = self.group_struct.find({"group":group})
		if struct_record.count() == 1:
			self.group_struct.update({"group":group}, {"$set":{"struct":struct}})
		else:
			self.group_struct.insert({"group":group, "struct":struct})
